<?php
/*
 Plugin Name: Support Tickets Center
 Plugin URI: http://www.zingiri.net/plugins-and-addons/tickets/
 Description: This plugin integrates the fabulous osTicket ticketing solution with Wordpress.
 Author: Zingiri
 Version: 1.2.3
 Author URI: http://www.zingiri.net/
 */

define("ZING_TICKETS_VERSION","1.2.3");

// Pre-2.6 compatibility for wp-content folder location
if (!defined("WP_CONTENT_URL")) {
	define("WP_CONTENT_URL", get_option("siteurl") . "/wp-content");
}
if (!defined("WP_CONTENT_DIR")) {
	define("WP_CONTENT_DIR", ABSPATH . "wp-content");
}

if (!defined("ZING_TICKETS_PLUGIN")) {
	$zing_tickets_plugin=str_replace(realpath(dirname(__FILE__).'/..'),"",dirname(__FILE__));
	$zing_tickets_plugin=substr($zing_tickets_plugin,1);
	define("ZING_TICKETS_PLUGIN", $zing_tickets_plugin);
}

if (!defined("ZING_TICKETS_SUB")) {
	if (get_option("siteurl") == get_option("home"))
	{
		define("ZING_TICKETS_SUB", "wp-content/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
	}
	else {
		define("ZING_TICKETS_SUB", "wordpress/wp-content/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
	}
}
if (!defined("ZING_TICKETS_DIR")) {
	define("ZING_TICKETS_DIR", WP_CONTENT_DIR . "/plugins/".ZING_TICKETS_PLUGIN."/osticket/upload/");
}

if (!defined("ZING_TICKETS_LOC")) {
	define("ZING_TICKETS_LOC", WP_CONTENT_DIR . "/plugins/".ZING_TICKETS_PLUGIN."/");
}

if (!defined("ZING_TICKETS_URL")) {
	define("ZING_TICKETS_URL", WP_CONTENT_URL . "/plugins/".ZING_TICKETS_PLUGIN."/");
}
if (!defined("ZING_TICKETS_LOGIN")) {
	define("ZING_TICKETS_LOGIN", get_option("zing_tickets_login"));
}

define("ZING_OST_URL",ZING_TICKETS_URL.'osticket/upload');

$zing_footers[]=array('http://www.osticket.com/','osTicket');
$zing_tickets_version=get_option("zing_tickets_version");
if ($zing_tickets_version) {
	add_action("init","zing_tickets_init");
	add_filter('wp_footer','zing_tickets_footer');
	add_filter('the_content', 'zing_tickets_content', 10, 3);
	add_action('wp_head','zing_tickets_header');
	add_action('admin_head','zing_tickets_admin_header');
	add_action('admin_notices','zing_tickets_admin_notices');
}

register_activation_hook(__FILE__,'zing_tickets_activate');
register_deactivation_hook(__FILE__,'zing_tickets_deactivate');
require_once(dirname(__FILE__) . '/includes/shared.inc.php');
require_once(dirname(__FILE__) . '/includes/http.class.php');
require_once(dirname(__FILE__) . '/includes/footer.inc.php');
require_once(dirname(__FILE__) . '/includes/integrator.inc.php');
require_once(dirname(__FILE__) . '/includes/log.inc.php');
require_once(dirname(__FILE__) . '/zing_tickets_cp.php');

function zing_tickets_admin_notices() {
	$messages=array();

	$upload=wp_upload_dir();
	if ($upload['error']) $messages[]=$upload['error'];
	if (phpversion() < '5')	$messages[]="You are running PHP version ".phpversion().". We recommend you ugprade to PHP version 5 or higher.";
	if (ini_get("zend.ze1_compatibility_mode")) $messages[]="You are running PHP in PHP 4 compatibility mode. We recommend to turn this mode off.";
	if (!get_option("zing_tickets_version")) $messages[]='Please proceed with a clean install or deactivate your plugin';
	elseif (get_option("zing_tickets_version") != ZING_TICKETS_VERSION) $messages[]='You downloaded version '.ZING_TICKETS_VERSION.' and need to upgrade your database (currently at version '.get_option("zing_tickets_version").').';
	if (!ini_get('short_open_tag')) $messages[]='Short open tag disabled! - osTicket requires it turned ON.';
	if (!is_writable(dirname(__FILE__).'/log.txt')) $messages[]='Make sure the file log.txt in the plugin directory is writable';

	if ($messages) {
		foreach ($messages as $message) {
			echo "<div id='zing-warning' style='background-color:greenyellow' class='updated fade'><p><strong>".$message."</strong> "."</p></div>";
		}
	}

}
/**
 * Activation: creation of database tables & set up of pages
 * @return unknown_type
 */
function zing_tickets_activate() {
	global $wpdb;
	global $current_user;
	global $zing_tickets_options;

	zing_tickets_log();

	zing_tickets_log('Installation/Upgrade');

	$zing_tickets_version=get_option("zing_tickets_version");

	//create database tables
	$prefix=$wpdb->prefix."zing_ost_";

	if ($handle = opendir(dirname(__FILE__).'/db')) {
		while (false !== ($file = readdir($handle))) {
			if (strstr($file,".sql")) {
				$f=explode("-",$file);
					
				$v=str_replace(".sql","",$f[1]);
				if ($zing_tickets_version < $v) {
					$file_content = file(dirname(__FILE__).'/db/'.$file);
					$query = "";
					foreach($file_content as $sql_line) {
						$tsl = trim($sql_line);
						if (($sql_line != "") && (substr($tsl, 0, 2) != "--") && (substr($tsl, 0, 1) != "#")) {
							$sql_line = str_replace("CREATE TABLE `", "CREATE TABLE `".$prefix, $sql_line);
							$sql_line = str_replace("DELETE FROM `", "DELETE FROM `".$prefix, $sql_line);
							$sql_line = str_replace("INSERT INTO `", "INSERT INTO `".$prefix, $sql_line);
							$sql_line = str_replace("ALTER TABLE `", "ALTER TABLE `".$prefix, $sql_line);
							$sql_line = str_replace("UPDATE `", "UPDATE `".$prefix, $sql_line);
							$sql_line = str_replace("TRUNCATE TABLE `", "TRUNCATE TABLE `".$prefix, $sql_line);
							$query .= $sql_line;

							if(preg_match("/;\s*$/", $sql_line)) {
								//echo $query.'<br />';
								$wpdb->query($query);
								//if (!mysql_query($query)) die('error: '.$query);
								$query = "";
							}
						}
					}
				}
			}
		}
		closedir($handle);
	}

	//default settings
	if ($zing_tickets_version <= '0.1') {
		$query="update ".$prefix."config set admin_email='".get_option('admin_email')."'";
		$query.=",helpdesk_url='".get_option('home')."'";
		$wpdb->query($query);
	}

	//default email
	if ($zing_tickets_version <= '0.1') {
		$query="update ".$prefix."email set email='".get_option('admin_email')."'";
		//$query.=",helpdesk_url='".get_option('home')."'";
		$wpdb->query($query);
	}

	//default user
	if (!$zing_tickets_version) {
		$query="INSERT INTO `".$prefix."staff` (`staff_id`, `group_id`, `dept_id`, `username`, `firstname`, `lastname`, `passwd`, `email`, `phone`, `phone_ext`, `mobile`, `signature`, `isactive`, `isadmin`, `isvisible`, `onvacation`, `daylight_saving`, `append_signature`, `change_passwd`, `timezone_offset`, `max_page_size`, `created`, `lastlogin`, `updated`) VALUES";
		$query.="('".$current_user->data->ID."', 1, 1, '".$current_user->data->user_login."', '".$current_user->first_name."', '".$current_user->last_name."', '".md5($current_user->data->user_pass)."', '".$current_user->data->user_email."', '', '', '', '', 1, 1, 1, 0, 0, 0, 0, 0.0, 0, '".date("Y-m-d")."', NULL, '".date("Y-m-d")."')";
		$wpdb->query($query);
		$query=sprintf("UPDATE `".$prefix."staff` SET `passwd`='%s', `change_passwd`=0 WHERE `username`='%s'",md5($current_user->data->user_pass),$current_user->data->user_login);
		$wpdb->query($query);
	}

	//upgrade osTicket to 1.6 ST
	zing_tickets_login();
	$http=zing_tickets_http("osticket","setup/upgrade.php");
	zing_tickets_log($http);
	$news = new zHttpRequest($http,'zingiri-tickets');
	$news->post=array('step' => 2);
	if ($news->live()) {
		//echo $http;
		$output=$news->DownloadToString();
		zing_tickets_log($output);
	}

	//default options
	if (is_array($zing_tickets_options) && count($zing_tickets_options) > 0) {
		foreach ($zing_tickets_options as $value) {
			delete_option( $value['id'] );
			if ( !empty($value['id']) && !get_option($value['id']) ) update_option( $value['id'], $value['std'] );
		}
	}

	//create standard pages
	if ($zing_tickets_version <= '0.1') {
		$pages=array();
		$pages[]=array("Tickets","tickets","*",0);

		$ids="";
		foreach ($pages as $i =>$p)
		{
			$my_post = array();
			$my_post['post_title'] = $p['0'];
			$my_post['post_content'] = '';
			$my_post['post_status'] = 'publish';
			$my_post['post_author'] = 1;
			$my_post['post_type'] = 'page';
			$my_post['comment_status'] = 'closed';
			$my_post['menu_order'] = 100+$i;
			$id=wp_insert_post( $my_post );
			if (empty($ids)) { $ids.=$id; } else { $ids.=",".$id; }
			if (!empty($p[1])) add_post_meta($id,'zing_tickets_page',$p[1]);
		}
		update_option("zing_tickets_pages",$ids);
	}

	//set comment status to closed
	$ids=get_option("zing_tickets_pages");
	$ida=explode(",",$ids);
	foreach ($ida as $id) {
		$my_post = array();
		$my_post['ID']=$id;
		$my_post['comment_status'] = 'closed';
		wp_update_post($my_post);
	}

	if (!$zing_tickets_version) update_option('zing_tickets_secret_salt',md5(__FILE__.md5(get_option('admin_email'))));

	update_option("zing_tickets_version",ZING_TICKETS_VERSION);

}

/**
 * Deactivation
 * @return void
 */
function zing_tickets_deactivate() {
	zing_tickets_uninstall();
}

/**
 * Uninstallation: removal of database tables
 * @return void
 */
function zing_tickets_uninstall() {
	global $wpdb;

	$tables=array();
	$a='api_key,config,department,email,email_banlist,email_template,groups,help_topic,kb_premade,staff,syslog,ticket,ticket_attachment,ticket_lock,ticket_message,ticket_note,ticket_priority,ticket_response,timezone';
	$tables=explode(",",$a);
	$prefix=$wpdb->prefix."zing_ost_";
	foreach ($tables as $table) {
		$query="drop table ".$prefix.$table;
		$wpdb->query($query);
	}
	$ids=get_option("zing_tickets_pages");
	$ida=explode(",",$ids);
	foreach ($ida as $id) {
		wp_delete_post($id);
	}
	delete_option("zing_tickets_version");
	delete_option("zing_tickets_pages");
	delete_option('zing_tickets_secret_salt');
}

/**
 * Main function handling content, footer and sidebars
 * @param $process
 * @param $content
 * @return unknown_type
 */
function zing_tickets_main($process,$content="") {
	global $zing_tickets_content;

	if ($zing_tickets_content) $content=$zing_tickets_content;
	return $content;
}

function zing_tickets_output($process) {

	global $post;
	global $wpdb;
	global $cfg;
	global $thisuser;
	global $nav;
	global $zing_tickets_loaded,$zing_tickets_mode;

	$content="";

	switch ($process)
	{
		case "content":
			if (isset($_POST['zname'])) {
				$_POST['name']=$_POST['zname'];
				unset($_POST['zname']);
			}
			if (isset($post)) $cf=get_post_custom($post->ID);
			if (isset($_GET['zpage']))
			{
				$to_include=$_GET['zpage'];
				$zing_tickets_mode="client";
			}
			elseif (isset($_GET['zscp']))
			{
				$to_include="scp/".$_GET['zscp'];
				$zing_tickets_mode="admin";
			}
			elseif (isset($_GET['zsetup']))
			{
				$to_include="setup/".$_GET['zscp'];
				$zing_tickets_mode="setup";
			}
			elseif (isset($cf['zing_tickets_page']))
			{
				$zing_tickets_mode="client";
				$to_include=$cf['zing_tickets_page'][0];
			}
			elseif (isset($cf['zing_tickets_page']) && ($cf['zing_tickets_page'][0]=='admin'))
			{
				$to_include="scp/".$_GET['zscp'];
				$zing_tickets_mode="admin";
			}
			elseif ($zing_tickets_mode=='menu')
			{
				$to_include="scp/index";
				$zing_tickets_mode="admin";
			}
			else
			{
				return $content;
			}
			if (isset($cf['cat'])) {
				$_GET['cat']=$cf['cat'][0];
			}
			break;
		default:
			return $content;
			break;
	}

	if (get_option("zing_tickets_subscribers") == "Subscribers" && !is_user_logged_in()) {
		$content="Access not allowed, please register or login first";
		return $content;
	}

	zing_tickets_login();
	$http=zing_tickets_http("osticket",$to_include.'.php');
	$news = new zHttpRequest($http,'zingiri-tickets');
	if ($news->live()) {
		$output=$news->DownloadToString();
		$content.=zing_tickets_ob($output);
		return $content;
	}
}

function zing_tickets_mainpage() {
	$ids=get_option("zing_tickets_pages");
	$ida=explode(",",$ids);
	return $ida[0];
}

function zing_tickets_ob($buffer) {
	global $current_user,$zing_tickets_mode;
	$home=get_option('home');
	$admin=get_option('siteurl').'/wp-admin';
	$pid=zing_tickets_mainpage();

	//login
	if (strpos($buffer,'loginBody')===false) $loginPage=false;
	else $loginPage=true;

	$buffer=zing_integrator_tags($buffer,"ost");
	$buffer=str_replace('"install.php"','"'.$home.'/index.php?page_id='.$pid.'&zpage=setup/install"',$buffer);
	$buffer=str_replace('action=install.php','action="'.$home.'/index.php?page_id='.$pid.'&zpage=setup/install"',$buffer);
	$buffer=str_replace('"style.css"','"'.ZING_OST_URL.'/setup/style.css"',$buffer);

	//admin
	$buffer=str_replace('../scp/admin.php','"'.$home.'/index.php?page_id='.$pid.'&zscp=admin"',$buffer);
	if ($zing_tickets_mode=="admin") {
		foreach (array('login','scp','main','style','tabs','autosuggest_inquisitor') as $css) {
			$buffer=str_replace('css/'.$css.'.css',ZING_TICKETS_URL.'css/admin/'.$css.'.css',$buffer);
		}
		foreach (array('ajax','tabber') as $js) {
			$buffer=str_replace('js/'.$js.'.js',ZING_OST_URL.'/scp/js/'.$js.'.js',$buffer);
		}
		foreach (array('bsn.AutoSuggest_2.1.3','autolock','calendar','scp') as $js) {
			$buffer=str_replace('js/'.$js.'.js',ZING_TICKETS_URL.'js/'.$js.'.js',$buffer);
		}
		foreach (array('index','admin','tickets','kb','directory','profile','logout') as $page) {
			if (is_admin()) {
				$buffer=str_replace('"'.$page.'.php?','"'.$admin.'/admin.php?page=zingiri-tickets-admin&zscp='.$page.'&',$buffer);
				$buffer=str_replace('"'.$page.'.php"','"'.$admin.'/admin.php?page=zingiri-tickets-admin&zscp='.$page.'"',$buffer);
				$buffer=str_replace("'".$page.'.php?',"'".$admin.'/admin.php?page=zingiri-tickets-admin&zscp='.$page.'&',$buffer);
				$buffer=str_replace("'".$page.'.php"',"'".$admin.'/admin.php?page=zingiri-tickets-admin&zscp='.$page.'"',$buffer);

			} else {
				$buffer=str_replace('"'.$page.'.php?','"'.$home.'/index.php?page_id='.$pid.'&zscp='.$page.'&',$buffer);
				$buffer=str_replace('"'.$page.'.php"','"'.$home.'/index.php?page_id='.$pid.'&zscp='.$page.'"',$buffer);
				$buffer=str_replace("'".$page.'.php?',"'".$home.'/index.php?page_id='.$pid.'&zscp='.$page.'&',$buffer);
				$buffer=str_replace("'".$page.'.php"',"'".$home.'/index.php?page_id='.$pid.'&zscp='.$page.'"',$buffer);
			}
		}
		$buffer=str_replace('attachment.php',ZING_TICKETS_URL.'attachment.php',$buffer);
		$buffer=str_replace('action="login.php"','action="'.$home.'/index.php?page_id='.$pid.'&zscp=login"',$buffer);
		$buffer=preg_replace('/.a id="logo".*a>/','',$buffer);
		$buffer=str_replace("src='images/","src='".ZING_OST_URL."/scp/images/",$buffer);
		$buffer=str_replace('src="images/','src="'.ZING_OST_URL.'/scp/images/',$buffer);
		$buffer=str_replace('method="get">','method="get"><input type="hidden" name="page_id" value="'.$pid.'" /><input type="hidden" name="zscp" value="admin" />',$buffer);
		$buffer=str_replace('method="GET" >','method="GET" ><input type="hidden" name="page_id" value="'.$pid.'" /><input type="hidden" name="zscp" value="admin" />',$buffer);
		$buffer=str_replace('src="autocron.php"','src="'.ZING_OST_URL.'/scp/autocron.php"',$buffer);

		//remove Change password option
		if (get_option('zing_tickets_login') == "WP") zing_integrator_cut($buffer,'<li><a class="userPasswd"','</li>');

		//missing div causes themes to break
		if (!$loginPage) $buffer='<div>'.$buffer;

		//client
	} elseif ($zing_tickets_mode=="client") {
		foreach (array('tickets','open','view','logout') as $page) {
			$buffer=str_replace('"'.$page.'.php?','"'.$home.'/index.php?page_id='.$pid.'&zpage='.$page.'&',$buffer);
			$buffer=str_replace('"'.$page.'.php"','"'.$home.'/index.php?page_id='.$pid.'&zpage='.$page.'"',$buffer);
		}
		foreach (array('main','colors') as $css) {
			$buffer=str_replace('./styles/'.$css.'.css',ZING_TICKETS_URL.'css/client/'.$css.'.css',$buffer);
		}
		$buffer=str_replace('id="header"','id="header" style="display:none"',$buffer);
		$buffer=str_replace('action="login.php"','action="'.$home.'/index.php?page_id='.$pid.'&zpage=login"',$buffer);
		$buffer=str_replace("src='images/","src='".ZING_OST_URL."/images/",$buffer);
		$buffer=str_replace('src="images/','src="'.ZING_OST_URL.'/images/',$buffer);
		$buffer=str_replace('<ul id="nav">','<ul id="ostnav">',$buffer);
		if (get_option("zing_tickets_subscribers") == "Subscribers" && is_user_logged_in()) zing_integrator_cut($buffer,'<a class="log_out"','</a>');
		$buffer=zing_tickets_translate($buffer);
	}

	$buffer=str_replace('<div id="content"','<div',$buffer);

	return '<!--buffer:start-->'.$buffer.'<!--buffer:end-->';
}

function zing_tickets_translate($buffer) {
	$lang=get_option("zing_tickets_lang");
	if ($lang=='' or $lang=='en') return $buffer;
	require(dirname(__FILE__).'/langs/en.inc.php');
	require(dirname(__FILE__).'/langs/'.$lang.'.inc.php');
	$c=get_defined_constants(true);
	foreach ($c['user'] as $n => $v) {
		if (strstr($n,'en_') !==false) {
			$m=str_replace('en_',$lang.'_',$n);
			if (defined($m)) $buffer=str_replace($v,constant($m),$buffer);
		}
	}
	return $buffer;
}

function zing_tickets_http($module,$to_include="index",$page="",$key="") {
	$vars="";
	if (!$to_include || $to_include==".php") $to_include="index";
	$http=ZING_OST_URL.'/';
	$http.= $to_include;
	$and="";

	$get=$_GET;
	$get['z']=md5(dirname(__FILE__).'/osticket/upload/scp/admin.php');
	$get['zing_admin_email']=get_option('admin_email');
	$get['zing_secret_salt']=get_option('zing_tickets_secret_salt');

	if (count($get) > 0) {
		foreach ($get as $n => $v) {
			if ($n!="zpage" && $n!="page_id" && $n!="zscp") {
				$vars.= $and.$n.'='.zing_urlencode($v);
				$and="&";
			}
		}
	}

	if ($vars) $http.= '?'.$vars;
	return $http;
}

/**
 * Page content filter
 * @param $content
 * @return unknown_type
 */
function zing_tickets_content($content) {
	return zing_tickets_main("content",$content);
}

function zing_tickets_admin_header()
{
	global $zingiri_tickets_head;

	if (!isset($_REQUEST['page']) || ($_REQUEST['page'] != 'zingiri-tickets-admin')) return;

	//stylesheets and javascripts
	echo '<script type="text/javascript" language="javascript">';
	echo "var ajaxurl='".ZING_TICKETS_URL."osticket/upload/scp/';";
	echo "var ajaxurlloc='".ZING_TICKETS_URL."ajax/';";
	echo '</script>';
	echo $zingiri_tickets_head;

	echo '<link rel="stylesheet" type="text/css" href="' . ZING_TICKETS_URL . 'admin.css" media="screen" />';
}

/**
 * Header hook: loads FWS addons and css files
 * @return unknown_type
 */
function zing_tickets_header() {
	global $zingiri_tickets_head;

	zing_tickets_ostickets_content();

	echo $zingiri_tickets_head;
	echo '<link rel="stylesheet" type="text/css" href="' . ZING_TICKETS_URL . 'zing.css" media="screen" />';
}

function zing_tickets_ostickets_content()
{
	global $zing_tickets_content;
	global $zing_tickets_menu,$zing_tickets_submenu,$zing_tickets_active_menu;
	global $zing_tickets_post,$zingiri_tickets_head;

	if (!class_exists('simple_html_dom')) require_once(dirname(__FILE__) . '/includes/simple_html_dom.php');

	if (isset($_POST) && isset($zing_tickets_post)) {
		$_POST=array_merge($_POST,$zing_tickets_post);
	}

	$output=zing_tickets_output("content");
	zing_integrator_cut($output,'<div id="footer">','</div>');
	$zingiri_tickets_head=zing_integrator_cut($output,'<div id="osthead">','</div>',true);

	//start menu
	$html = new simple_html_dom();
	$html->load($output);
	$i=0;
	foreach ($html->find('p[id=info] a') as $m) {
		if (!empty($m->innertext) && (strstr($m->href,'zscp=index') || strstr($m->href,'zscp=admin'))) {
			$zing_tickets_menu[]=array($m->innertext,$m->href);
			$i++;
		}
	}

	$zing_tickets_active_menu=0;
	foreach ($html->find('ul[id=main_nav] li a') as $m) {
		if (!empty($m->innertext)) {
			$zing_tickets_menu[]=array($m->innertext,$m->href);
			if ($m->class == 'active') $zing_tickets_active_menu=$i;
			$i++;
		}
	}

	foreach ($html->find('ul[id=sub_nav] li a') as $m) {
		$zing_tickets_submenu[]=array($m->innertext,$m->href);
	}

	$menu=zing_integrator_cut($output,'<div id="nav">','</div>');

	zing_integrator_cut($output,'<div id="header"','</div>');
	$zing_tickets_content=$output;

}

/**
 * Initialization of page, action & page_id arrays
 * @return unknown_type
 */
function zing_tickets_init()
{
	global $zing_tickets_post;
	if (isset($_POST['name']) && (isset($_POST['submit_x']) || isset($_POST['submit']))) {
		$zing_tickets_post['name']=$_POST['name'];
		unset($_POST['name']);
	}

	ob_start();
	session_start();
	if (isset($_GET['zpage']) && !isset($_GET['page_id'])) $_GET['page_id']=zing_tickets_mainpage();
}

function zing_tickets_login() {
	global $current_user,$wpdb;

	if (current_user_can('edit_plugins')  || current_user_can('edit_pages')) {
		$post['do']='scplogin';
		$post['username']=$current_user->data->user_login;
		$post['passwd']=$current_user->data->user_pass;
		$post['submit']='Login';
		$http=zing_tickets_http('osticket','scp/login.php');
	} elseif (defined("ZING_TICKETS_LOGIN") && ZING_TICKETS_LOGIN=="WP" && is_user_logged_in()) {
		//Guest login extension
		include(dirname(__FILE__).'/extensions/guest_login.php');
	}
	if ($http) {
		$news = new zHttpRequest($http,'zingiri-tickets');
		$news->post=$post;
		if ($news->live()) {
			$output=$news->DownloadToString();
		}
	}

}
/**
 * Display common footer
 * @param $page_id
 * @return unknown_type
 */
function zing_tickets_footer() {
	zing_footers();
}
